import { IRootPosition } from '../positioning';
import * as lsProtocol from 'vscode-languageserver-protocol';
import * as CodeMirror from 'codemirror';
import { CodeMirrorIntegration, IEditorRange } from '../editor_integration/codemirror';
import { FeatureSettings, IFeatureLabIntegration } from '../feature';
import { EditorTooltipManager } from '../components/free_tooltip';
import { JupyterFrontEnd, JupyterFrontEndPlugin } from '@jupyterlab/application';
import { IRenderMimeRegistry } from '@jupyterlab/rendermime';
import { ILSPAdapterManager } from '../tokens';
import { CodeHover as LSPHoverSettings, ModifierKey } from '../_hover';
import { LabIcon } from '@jupyterlab/ui-components';
export declare const hoverIcon: LabIcon;
export declare class HoverCM extends CodeMirrorIntegration {
    protected hover_character: IRootPosition;
    private last_hover_response;
    private show_next_tooltip;
    private last_hover_character;
    protected hover_marker: CodeMirror.TextMarker;
    private virtual_position;
    lab_integration: HoverLabIntegration;
    settings: FeatureSettings<LSPHoverSettings>;
    private debounced_get_hover;
    get modifierKey(): ModifierKey;
    register(): void;
    on_hover: () => Promise<lsProtocol.Hover>;
    protected static get_markup_for_hover(response: lsProtocol.Hover): lsProtocol.MarkupContent;
    handleHover: (response: lsProtocol.Hover, documentUri: string) => void;
    protected is_token_empty(token: CodeMirror.Token): boolean;
    protected is_event_inside_visible(event: MouseEvent): boolean;
    _handleMouseOver(event: MouseEvent): Promise<void>;
    handleMouseOver: (event: MouseEvent) => Promise<void>;
    protected editor_range_for_hover(range: lsProtocol.Range): IEditorRange;
    hide_hover(): void;
    protected remove_range_highlight: () => void;
    remove(): void;
}
declare class HoverLabIntegration implements IFeatureLabIntegration {
    tooltip: EditorTooltipManager;
    settings: FeatureSettings<any>;
    constructor(app: JupyterFrontEnd, settings: FeatureSettings<any>, renderMimeRegistry: IRenderMimeRegistry, adapterManager: ILSPAdapterManager);
}
export declare const HOVER_PLUGIN: JupyterFrontEndPlugin<void>;
export {};
