import { CodeMirrorIntegration } from '../editor_integration/codemirror';
import { JupyterFrontEndPlugin } from '@jupyterlab/application';
import { LabIcon } from '@jupyterlab/ui-components';
import { IEditorIntegrationOptions, IFeatureLabIntegration, IFeatureSettings } from '../feature';
import { IEditorMimeTypeService } from '@jupyterlab/codeeditor/lib/mimetype';
import { CodeSyntax as LSPSyntaxHighlightingSettings } from '../_syntax_highlighting';
export declare const syntaxHighlightingIcon: LabIcon;
export declare class CMSyntaxHighlighting extends CodeMirrorIntegration {
    lab_integration: SyntaxLabIntegration;
    settings: IFeatureSettings<LSPSyntaxHighlightingSettings>;
    constructor(options: IEditorIntegrationOptions);
    private get_mode;
    update_mode(): void;
}
declare class SyntaxLabIntegration implements IFeatureLabIntegration {
    mimeTypeService: IEditorMimeTypeService;
    settings: IFeatureSettings<LSPSyntaxHighlightingSettings>;
    constructor(mimeTypeService: IEditorMimeTypeService);
}
export declare const SYNTAX_HIGHLIGHTING_PLUGIN: JupyterFrontEndPlugin<void>;
export {};
